MODULE Queue ;

TYPE Index = [0..Capacity] ;

VAR store      : ARRAY Index OF Item ;
    head, tail : Index ;


PROCEDURE Put(item : Item) =
BEGIN 
    <* ASSERT NOT IsFull() *>

    store[tail] := item ;

    IF (tail < Capacity) THEN
        INC(tail) ;
    ELSE
        tail := 0 ;
    END ;
END Put ;


PROCEDURE Get() : Item =
VAR item : Item ;
BEGIN
    <* ASSERT NOT IsEmpty() *>

    item := store[head] ;

    IF (head < Capacity) THEN
        INC(head) ;
    ELSE
        head := 0 ;
    END ;

    RETURN item ;
END Get ;


PROCEDURE IsFull() : BOOLEAN =
BEGIN
    IF head = 0 THEN
        RETURN tail = Capacity ;
    ELSE
        RETURN tail = head - 1 ;
    END ;
END IsFull ;


PROCEDURE IsEmpty() : BOOLEAN =
BEGIN
    RETURN head = tail ;
END IsEmpty ;


BEGIN
    head := 0 ;
    tail := 0 ;
END Queue .
